libcamera: libcamera::ipa::Algorithm< _Module > Class Template Reference

libcamera v0.3.2 Supporting cameras in Linux since 2019

Loading...
Searching...
No Matches
Public Types | Public Member Functions | List of all members
libcamera::ipa::Algorithm< _Module > Class Template Reference

The base class for all IPA algorithms. More...

Inheritance diagram for libcamera::ipa::Algorithm< _Module >:
[legend]

## Public Types
using | Module = _Module
| The IPA module type for this class of algorithms.

## Public Member Functions
virtual int | init (typename Module::Context &context, const YamlObject &tuningData)
| Initialize the Algorithm with tuning data.
virtual int | configure (typename Module::Context &context, const typename Module::Config &configInfo)
| Configure the Algorithm given an IPAConfigInfo.
virtual void | queueRequest (typename Module::Context &context, const uint32_t frame, typename Module::FrameContext &frameContext, const ControlList &controls)
| Provide control values to the algorithm.
virtual void | prepare (typename Module::Context &context, const uint32_t frame, typename Module::FrameContext &frameContext, typename Module::Params *params)
| Fill the params buffer with ISP processing parameters for a frame.
virtual void | process (typename Module::Context &context, const uint32_t frame, typename Module::FrameContext &frameContext, const typename Module::Stats *stats, ControlList &metadata)
| Process ISP statistics, and run algorithm operations.

## Detailed Description

template<typename _Module>
class libcamera::ipa::Algorithm< _Module >

The base class for all IPA algorithms.

Template Parameters

  Module | The IPA module type for this class of algorithms

The Algorithm class defines a standard interface for IPA algorithms compatible with the Module. By abstracting algorithms, it makes possible the implementation of generic code to manage algorithms regardless of their specific type.

To specialize the Algorithm class template, an IPA module shall specialize the Module class template with module-specific context and configuration types, and pass the specialized Module class as the Module template argument.

## Member Function Documentation

## ◆ configure()

template<typename _Module >

virtual int libcamera::ipa::Algorithm< _Module >::configure | ( | typename Module::Context & | context,
|  | const typename Module::Config & | configInfo )
| inlinevirtual

Configure the Algorithm given an IPAConfigInfo.

Parameters

  [in] | context | The shared IPA context
  [in] | configInfo | The IPA configuration data, received from the pipeline handler

Algorithms may implement a configure operation to pre-calculate parameters prior to commencing streaming.

Configuration state may be stored in the IPASessionConfiguration structure of the IPAContext.

Returns
  0 if successful, an error code otherwise

## ◆ init()

template<typename _Module >

virtual int libcamera::ipa::Algorithm< _Module >::init | ( | typename Module::Context & | context,
|  | const YamlObject & | tuningData )
| inlinevirtual

Initialize the Algorithm with tuning data.

Parameters

  [in] | context | The shared IPA context
  [in] | tuningData | The tuning data for the algorithm

This function is called once, when the IPA module is initialized, to initialize the algorithm. The tuningData YamlObject contains the tuning data for algorithm.

Returns
  0 if successful, an error code otherwise

## ◆ prepare()

template<typename _Module >

virtual void libcamera::ipa::Algorithm< _Module >::prepare | ( | typename Module::Context & | context,
|  | const uint32_t | frame,
|  | typename Module::FrameContext & | frameContext,
|  | typename Module::Params * | params )
| inlinevirtual

Fill the params buffer with ISP processing parameters for a frame.

Parameters

  [in] | context | The shared IPA context
  [in] | frame | The frame context sequence number
  [in] | frameContext | The FrameContext for this frame
  [out] | params | The ISP specific parameters

This function is called for every frame when the camera is running before it is processed by the ISP to prepare the ISP processing parameters for that frame.

Algorithms shall fill in the parameter structure fields appropriately to configure the ISP processing blocks that they are responsible for. This includes setting fields and flags that enable those processing blocks.

## ◆ process()

template<typename _Module >

virtual void libcamera::ipa::Algorithm< _Module >::process | ( | typename Module::Context & | context,
|  | const uint32_t | frame,
|  | typename Module::FrameContext & | frameContext,
|  | const typename Module::Stats * | stats,
|  | ControlList & | metadata )
| inlinevirtual

Process ISP statistics, and run algorithm operations.

Parameters

  [in] | context | The shared IPA context
  [in] | frame | The frame context sequence number
  [in] | frameContext | The current frame's context
  [in] | stats | The IPA statistics and ISP results
  [out] | metadata | Metadata for the frame, to be filled by the algorithm

This function is called while camera is running for every frame processed by the ISP, to process statistics generated from that frame by the ISP. Algorithms shall use this data to run calculations, update their state accordingly, and fill the frame metadata.

Processing shall not take an undue amount of time, and any extended or computationally expensive calculations or operations must be handled asynchronously in a separate thread.

Algorithms can store state in their respective IPAFrameContext structures, and reference state from the IPAFrameContext of other algorithms.

Todo
  Historical data may be required as part of the processing. Either the previous frame, or the IPAFrameContext state of the frame that generated the statistics for this operation may be required for some advanced algorithms to prevent oscillations or support control loops correctly. Only a single IPAFrameContext is available currently, and so any data stored may represent the results of the previously completed operations.

Care shall be taken to ensure the ordering of access to the information such that the algorithms use up to date state as required.

## ◆ queueRequest()

template<typename _Module >

virtual void libcamera::ipa::Algorithm< _Module >::queueRequest | ( | typename Module::Context & | context,
|  | const uint32_t | frame,
|  | typename Module::FrameContext & | frameContext,
|  | const ControlList & | controls )
| inlinevirtual

Provide control values to the algorithm.

Parameters

  [in] | context | The shared IPA context
  [in] | frame | The frame number to apply the control values
  [in] | frameContext | The current frame's context
  [in] | controls | The list of user controls

This function is called for each request queued to the camera. It provides the controls stored in the request to the algorithm. The frame number is the Request sequence number and identifies the desired corresponding frame to target for the controls to take effect.

Algorithms shall read the applicable controls and store their value for later use during frame processing.

The documentation for this class was generated from the following files:

- src/ipa/libipa/algorithm.h
- src/ipa/libipa/algorithm.cpp